window.dataStore = {}

export function create(storeName) {
	dataStore[storeName] = {};

	return dataStore[storeName];
}

export function insert(storeName, object) {
	if (typeof dataStore[storeName] !== 'undefined') {
		dataStore[storeName] = object;
	} else {
		throw storeName + ' is not empty! Use "set" for setting a value';
	}

	return dataStore[storeName];
}

export function empty(storeName, key) {
	dataStore[storeName][key] = '';

	return dataStore[storeName];
};

export function remove(storeName, key) {
	delete dataStore[storeName][key];

	return dataStore[storeName];
}

export function destroy(storeName) {
	delete dataStore[storeName];

	return dataStore;
}

export function get(storeName, key) {
	return dataStore[storeName][key];
}

export function set(storeName, key, value) {
	dataStore[storeName][key] = value;

	return dataStore[storeName];
}

export function list(storeName) {
	return dataStore[storeName];
}

let compare = {
	'gt': function(a, b) { return a > b },
	'lt': function(a, b) { return a < b },
	'gte': function(a, b) { return a >= b },
	'lte': function(a, b) { return a <= b },
	'eq': function(a, b) { return a == b },
}

export function find(storeName, query) {
	let operator = 'eq';
	let value = query;
	let result = [];

	if (typeof query == 'object') {
		operator = Object.keys(query)[0];
		value = query[operator];
	}

	for (key in dataStore[storeName]) {
		if (compare[operator](dataStore[storeName][key], value)) {
			let doc = {};
			doc[key] = dataStore[storeName][key];
			result.push(doc);
		}
	}

	return result;
}

export function findOne(storeName, query) {
	let operator = 'eq';
	let value = query;
	let result = [];

	if (typeof query == 'object') {
		operator = Object.keys(query)[0];
		value = query[operator];
	}

	for (key in dataStore[storeName]) {
		if (compare[operator](dataStore[storeName][key], value)) {
			let doc = {};
			doc[key] = dataStore[storeName][key];
			return doc;
		}
	}

	return false;
}
