window.dataStore = {}

function create(storeName) {
	dataStore[storeName] = {};

	return dataStore[storeName];
}

function insert(storeName, object) {
	if (typeof dataStore[storeName] !== 'undefined') {
		dataStore[storeName] = object;
	} else {
		throw storeName + ' is not empty! Use "set" for setting a value';
	}

	return dataStore[storeName];
}

let compare = {
	'gt': function(a, b) { return a > b },
	'lt': function(a, b) { return a < b },
	'gte': function(a, b) { return a >= b },
	'lte': function(a, b) { return a <= b },
	'eq': function(a, b) { return a == b },
}

function findOne(storeName, query) {
	let operator = 'eq';
	let value = query;
	let result = [];

	if (typeof query == 'object') {
		operator = Object.keys(query)[0];
		value = query[operator];
	}

	for (key in dataStore[storeName]) {
		if (compare[operator](dataStore[storeName][key], value)) {
			let doc = {};
			doc[key] = dataStore[storeName][key];
			return doc;
		}
	}

	return false;
}

create('test');

insert('test', {
	name: 'test',
	prop: {
		nested: 10
	},
});

console.log(findOne('test', 'test'));